;;; FG42 --- The mighty editor for the emacsians -*- lexical-binding: t; -*-
;;
;; Copyright (c) 2010-2024 Sameer Rahmani & Contributors
;;
;; Author: Sameer Rahmani <lxsameer@gnu.org>
;; URL: https://devheroes.codes/FG42/FG42
;; Version: 4.0.0
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;
;;; Commentary:
;;; Code:
(eval-when-compile
  (require 'fpkg))


(use! flycheck-clj-kondo
  "flycheck linter for clojure using `clj-konda'"
  :defer t)

;; (defun fg42/clojure-ts-mode-setup ()
;;   "A hook handler to setup cpp related configurations."
;;   ;; We set eglot's autoload command to `eglot-ensure'
;;   (eglot-ensure))

(use! clojure-ts-mode
  "Clojure mode"
  ;; :init
  ;; (add-to-list 'major-mode-remap-alist '(clojure-mode . clojure-ts-mode))
  :mode (("\\.clj\\'" . clojure-ts-mode)
         ("\\.cljs\\'" . clojure-ts-mode)
	 ("\\.cljc\\'" . clojure-ts-mode))
  :config
    (with-eval-after-load 'eglot
      ;; Force nil to use nixpkgs-fmt for formatting
      (let ((clojure-lsp '(clojure-ts-mode . clojure-mode)))
        (require 'flycheck-clj-kondo)
        (add-to-list 'eglot-server-programs clojure-lsp)))

  :hook
  (clojure-ts-mode . company-mode)
  (clojure-ts-mode . cider)
  (clojure-ts-mode . eglot-ensure))

(provide 'fg42/langs/clojure)
;;; clojure.el ends here
